﻿using Microsoft.Win32;
using System;
using System.Runtime.InteropServices;

namespace CsharpTest
{
    /// <summary>
    /// 프로그램
    /// </summary>
    class Program
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 닷넷 프레임워크 버전 구하기 - GetDotNetFrameworkVersion(releaseKey)

        /// <summary>
        /// 닷넷 프레임워크 버전 구하기
        /// </summary>
        /// <param name="releaseKey">릴리즈 키</param>
        /// <returns>닷넷 프레임워크 버전</returns>
        private static string GetDotNetFrameworkVersion(int releaseKey)
        {
            if(releaseKey >= 528040)
            {
                return "4.8 이상";
            }

            if(releaseKey >= 461808)
            {
                return "4.7.2";
            }

            if(releaseKey >= 461308)
            {
                return "4.7.1";
            }

            if(releaseKey >= 460798)
            {
                return "4.7";
            }

            if(releaseKey >= 394802)
            {
                return "4.6.2";
            }

            if(releaseKey >= 394254)
            {
                return "4.6.1";
            }

            if(releaseKey >= 393295)
            {
                return "4.6";
            }

            if(releaseKey >= 379893)
            {
                return "4.5.2";
            }

            if(releaseKey >= 378675)
            {
                return "4.5.1";
            }

            if(releaseKey >= 378389)
            {
                return "4.5";
            }

            return "4.5 또는 이상 버전을 발견할 수 없습니다.";
        }

        #endregion
        #region 프로그램 시작하기 - Main()

        /// <summary>
        /// 프로그램 시작하기
        /// </summary>
        private static void Main()
        {
            Console.WriteLine($"Environment.Version : {Environment.Version}");

            const string keyName = @"SOFTWARE\Microsoft\NET Framework Setup\NDP\v4\Full\";

            using(RegistryKey registryKey = RegistryKey.OpenBaseKey(RegistryHive.LocalMachine, RegistryView.Registry32).OpenSubKey(keyName))
            {
                if(registryKey != null && registryKey.GetValue("Release") != null)
                {
                    string version = GetDotNetFrameworkVersion((int)registryKey.GetValue("Release"));

                    Console.WriteLine($"닷넷 프레임워크 버전 : {version}");
                }
                else
                {
                    Console.WriteLine("닷넷 프레임워크 버전 4.5 이상을 발견할 수 없습니다.");
                }
            }

            Console.WriteLine($"RuntimeInformation.FrameworkDescription : {RuntimeInformation.FrameworkDescription}");
        }

        #endregion
    }
}